#include <propeller.h>
#include <stdint.h>
#include <stdio.h>
#include "mailbox.h"

/**
 * This is the main IOTest program file.
 */

/*
 * This is the structure which we'll pass to the C cog.
 * It contains a small stack for working area, and the
 * mailbox which we use to communicate. See toggle.h
 * for the definition/
 */
static struct {
    unsigned stack[16];
    volatile ioDriverMailbox_t ioDriverMailbox;
} ioDriverPar;

/*
 * function to start up a new cog running the io drivaer
 * code (which we've placed in the IODriver.cog section)
 */
uint8_t start(volatile void *parptr) {
  extern uint32_t *IODriver_code;
  #if defined(__PROPELLER_XMM__) || defined(__PROPELLER_XMMC__)
    return load_cog_driver_xmm(IODriver_code, 496, (uint32_t *)parptr);
  #else 
    return cognew(IODriver_code, parptr);
  #endif
}

int main(void) {
  for (int i = 0; i < 64; i++) {
    ioDriverPar.ioDriverMailbox.outputPort[i] = 1;
  }

  /* start the new cog */
  uint8_t cogId = start(&ioDriverPar.ioDriverMailbox);
  // Stop the cog.
  // cogstop(cogId);

  while (1) {
    //printf("shifted in value %d\n", ioDriverPar.ioDriverMailbox.shiftedInValue);
    //for (int i = 63; i >= 0; i--) {
    //  printf("%d ", ioDriverPar.ioDriverMailbox.inputPort[i]);
    //}
    //printf("\n");
    printf("Loop took: %d\n", ioDriverPar.ioDriverMailbox.loopTicks);

    waitcnt(40000000 + CNT);
  }
  return 0;
}

